## whitakers-words 0.2020.10.27

=== Makefile ===
# Makefile for Whitaker's words

GPRBUILD                                := gprbuild
GPRBUILD_OPTIONS                        := -j4

# Build flags are commonly found in the environment, but if they are
# set on our Make command line, forward them to GNAT projects.
export ADAFLAGS                         ?=
export LDFLAGS                          ?=

# For each library, a static archive is built by default but a
# non-empty shared object version selects a relocatable library
export latin_utils_soversion            :=
export support_utils_soversion          :=
export words_engine_soversion           :=

# Directory where dictionnary files are created and searched for.
# This variable is expected to be overridden at build time, with some
# architecture-specific value like $(prefix)/share/whitakers-words).
# At run time, another directory can be selected via the
# WHITAKERS_WORDS_DATADIR environment variable.
datadir                                 := .
# During (re)builds, the tools must read and test the fresh data and
# ignore any previous version already installed in $(datadir).
export WHITAKERS_WORDS_DATADIR := .

generated_sources := src/latin_utils/latin_utils-config.adb

PROGRAMMES := makedict makeefil makeewds makeinfl makestem meanings wakedict \
  words

.PHONY: all

all: commands data

# This target is more efficient than separate gprbuild runs because
# the dependency graph is only constructed once.
.PHONY: commands
commands: $(generated_sources)
	$(GPRBUILD) -p $(GPRBUILD_OPTIONS) commands.gpr

# Targets delegated to gprbuild are declared phony even if they build
# concrete files, because Make ignores all about Ada dependencies.
.PHONY: $(PROGRAMMES)
$(PROGRAMMES): $(generated_sources)
	$(GPRBUILD) -p $(GPRBUILD_OPTIONS) commands.gpr $@

.PHONY: sorter
sorter: $(generated_sources)
	$(GPRBUILD) -p $(GPRBUILD_OPTIONS) tools.gpr $@

# Executable targets are phony (see above), so we tell Make to only
# check that they exist but ignore the timestamp.  This is not
# perfect, but at least Make
# * updates the output data if the input data changes
# * builds the generator if it does not exist yet

DICTFILE.GEN: DICTLINE.GEN | wakedict
	echo g | bin/wakedict $< > /dev/null
	mv STEMLIST.GEN STEMLIST_generated.GEN

STEMLIST.GEN: DICTLINE.GEN | sorter
	rm -f -- $@
	bin/sorter < stemlist-sort.txt > /dev/null
	mv -f -- STEMLIST_new.GEN $@
	rm -f STEMLIST_generated.GEN
	rm -f WORK.

EWDSFILE.GEN: EWDSLIST.GEN | makeefil
	bin/makeefil

EWDSLIST.GEN: DICTLINE.GEN | makeewds
	echo g | bin/makeewds $< > /dev/null
	sort -o $@ $@

INFLECTS.SEC: INFLECTS.LAT | makeinfl
	bin/makeinfl $< > /dev/null

STEMFILE.GEN INDXFILE.GEN: STEMLIST.GEN | makestem
	echo g | bin/makestem $< > /dev/null

GENERATED_DATA_FILES := DICTFILE.GEN STEMFILE.GEN INDXFILE.GEN EWDSLIST.GEN \
					INFLECTS.SEC EWDSFILE.GEN STEMLIST.GEN

.PHONY: data

data: $(GENERATED_DATA_FILES)

.PHONY: clean_data

clean_data:
	rm -f $(GENERATED_DATA_FILES) CHECKEWD.

.PHONY: clean

clean: clean_data
	rm -fr bin lib obj
	rm -f WORK. STEMLIST_generated.GEN STEMLIST_new.GEN $(generated_sources)

$(generated_sources): %: %.in Makefile
	sed 's|@datadir@|$(datadir)|' $< > $@

.PHONY: test

test: all
	cd test && ./run-tests.sh

# This Makefile does not support parallelism (but gprbuild does).
.NOTPARALLEL:

=== debian/changelog ===
whitakers-words (0.2020.10.27-1.5) unstable; urgency=medium

  * Non-maintainer upload.
  * Disable stack check on arm{el,hf} because of #1096181.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 20 Mar 2025 21:08:08 +0000

whitakers-words (0.2020.10.27-1.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Rebuild with gnat-14.
  * Disable compiler error on warnings. Closes: #1067285.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 20 Mar 2025 10:10:16 +0100

whitakers-words (0.2020.10.27-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Rebuild with gnat-12 and packaging.mk from dh-ada-library/8.1.
  * Set -m gprbuild option and avoid lots of unneeded compilations.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 01 Jan 2023 17:57:33 +0000

whitakers-words (0.2020.10.27-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Rebuild with gnat-11, debian_packaging-*.mk now depends on buildopts.mk

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 11 May 2022 20:54:24 +0000

whitakers-words (0.2020.10.27-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * No-change rebuild with gnat-10 as default

 -- Graham Inggs <ginggs@debian.org>  Sun, 13 Dec 2020 00:32:36 +0000

whitakers-words (0.2020.10.27-1) unstable; urgency=low

  * Initial release. Closes: 971408
  * This Debian version is based on upstream commit 4571565


 -- Calum McConnell <calumlikesapplepie@gmail.com>  Mon, 02 Nov 2020 18:54:34 -0500

=== debian/control ===
Source: whitakers-words
Section: education
Priority: optional
Maintainer: Calum McConnell <calumlikesapplepie@gmail.com>
Build-Depends:
 asciidoctor,
 debhelper-compat (=13),
 dh-ada-library (>= 8.1),
 gnat,
 gprbuild,
Standards-Version: 4.5.0
Homepage: http://mk270.github.io/whitakers-words/
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/CalumMcConnell-guest/whitakers-words
Vcs-Git: https://salsa.debian.org/CalumMcConnell-guest/whitakers-words.git

Package: whitakers-words
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, whitakers-words-data
Description: Latin word parser and translation aid
 Whitakers Words is a program that takes in words in Latin,
 and analyzes them to determine the stems, case, form,  and any
 possible  translations.  It can also provide Latin words with
 a given translation, going from Latin to English.  It is
 an invaluable tool for Latin users, be they experts or
 new learners.
 .
 Words was created by Willam Whitaker (1936-2010) as a
 curiosity that demonstrated his new programming language,
 Ada.  It was since improved and iterated on, ported away
 from it's DOS roots, and given an online access point.
 .
 This package contains the executable parser program.

Package: whitakers-words-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Latin word parser and translation aid - data
 Whitakers Words is a program that takes in words in Latin,
 and analyzes them to determine the stems, case, form,  and any
 possible  translations.  It can also provide Latin words with
 a given translation, going from Latin to English.  It is
 an invaluable tool for Latin users, be they experts or
 new learners.
 .
 Words was created by Willam Whitaker (1936-2010) as a
 curiosity that demonstrated his new programming language,
 Ada.  It was since improved and iterated on, ported away
 from is DOS roots, and given an online access point.
 .
 This package contains the Latin dictionaries.
 You should never need to select it explicitly.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

# Disable the -gnatwe upstream flags during Debian builds (#1067285).
DEB_ADAFLAGS_MAINT_APPEND := -gnatwn

# work-around for #1096181.
ifneq (,$(filter $(DEB_HOST_ARCH),armel armhf))
  DEB_ADAFLAGS_MAINT_APPEND += -fno-stack-check
endif

DEB_BUILD_MAINT_OPTIONS := hardening=+all
DPKG_EXPORT_BUILDFLAGS := 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/ada/packaging.mk

%:
	dh $@

# The -m gprbuild flag prevents a lot of unneeded compilations.
# TODO: forward upstream
make_args := \
  datadir=/usr/share/whitakers-words \
  GPRBUILD_OPTIONS='$(GPRBUILDFLAGS) -m'

# The dictionaries are generated by executables, so -arch and -indep
# targets almost have the same build-dependencies and there is not
# much point in separating them.
# Moreover, the tests require both the executable and the dictionaries.

override_dh_auto_build: debian/whitakers-words.1
	dh_auto_build -- $(make_args)
	cp --update bin/words bin/whitakers-words

debian/whitakers-words.1: %.1: %.asciidoc
	asciidoctor -b manpage $<

override_dh_auto_test:
	dh_auto_test -- $(make_args)

=== debian/tests/control ===
Test-Command: test/run-tests.sh --prog=whitakers-words --datadir=/usr/share/whitakers-words

=== debian/watch ===
# Upstream DOES NOT distribute tags.  Any tags present in the
# Salsa repository were added by me, after the fact. 
# As far as I can tell, uscan does not support this, and is
# therefore not usable
